#ifndef ACTIONS_H
#define ACTIONS_H

#include <QObject>
#include <QAction>
#include <QWidgetAction>
#include <QSpinBox>
#include<QMenu>
class Actions : public QObject
{
    Q_OBJECT
public:
    explicit Actions(QLocale lc,QObject *parent = 0);

    //Books______________________________________________
    QList<QAction *>listCatBooks(){return mListcatBooks;}
    QList<QAction *>listViewBooks(){return mListViewBooks;}
    QList<QAction *>listEditBooks(){return mListEditBooks;}
 QList<QAction *>listToolBarBooks(){return mListToolBarBooks;}
    //Pdfs________________________________________________
    QList<QAction *>listEditPdf(){return mListEditPdf;}
    QList<QAction *>listViewPdf(){return mListViewPdf;}
    QList<QAction *>listToolBarPdf(){return mListToolBarPdf;}
signals:

    //Books______________________________________________SIGNAL
    void emitRootPath();
    void emitEditBook();
    void emitDeletSelectedIndexes();
    void viewModeChanged(int);
    void categoryChanged(int);

    //Pdfs________________________________________________SIGNAL
  //  void pdfToggleContentVisible(bool);
    void pdfEmitFirstPage();
    void pdfEmitPreviousPage();
    void currentPageChanged(int);
    void pdfEmitNextPage();
    void pdfEmitLastPage();
    void pdfEmitAddBookmark();
    void pdfRefresh();
    void pdfEmitZoomIn();
    void pdfEmitZoomOut();
    void pdfEmitSetRubberBand(bool);
    void pdfEmitSetInvertColors(bool);
    void pdfSetPage(int);
    void pdfSetContinousMode(bool);
    void pdfSetFiteWith(int );
    void pdfSetLayoutMode(int );

public slots:
  void setSpinPages(int numPages,int page);
  void setRubberBandAct(bool arg);
//  void setPdfContentVisibleAct(bool arg);
  void setFitSizeAct(int fit);
     void setLayoutModeAct(int layout);
     void setContinousModeAct(bool arg);
     void setInvertcolorsAct(bool arg);
private slots:

    //Books______________________________________________
    void setupBooksActions();
    void toggleView(QAction* action);
    void toggleRootPath(QAction* action);

    //Pdfs________________________________________________
    void setupPdfs();
    void pdfGoPage();
    void disableFite();
    void setFitSizeAct(QAction* act);

    void setLayoutModeAct(QAction* act);

private:
    QLocale mlocale;
    //Books______________________________________________
    enum CateGory{
        CAT_GROUP,
        CAT_AUTHOR,
        CAT_FAVORIT,
        CAT_SEARCH
    };

    enum ViewMode{
        IconView,
        DetailView
    };

    QAction *mActDelete;
    QAction *mActEditBook;
    QAction *mActRootPath;
    QAction *mActGroopPath;
    QAction *mActAutorPath;
    QAction *mActFavoPath;
    QAction *actIconView;
    QAction *actDetailView;

    QAction *actPath;
    QMenu *menuPath;
    QActionGroup  *alignViewMode;
    QActionGroup  *alignRootPath;

    QList<QAction*>mListcatBooks;
    QList<QAction*>mListViewBooks;
    QList<QAction*>mListEditBooks;
    QList<QAction*>mListToolBarBooks;


    //Pdfs________________________________________________
    QAction *mActShowHide;
    QAction *mActFirst;
    QAction *mActPrev;
    QAction *mActNext;
    QAction *mActLast;
    QWidgetAction *mActSpin;
    QSpinBox *mSpinBox;
    QAction *mActAddBookmark;
    QAction *mActRefresh;
    QAction *mActZoomIn;
    QAction *mActZoomOut;
    QActionGroup *mAlignActionsFite;
    QAction *mActOriginalSize;
    QAction *mActZoomFit;
    QAction *mActZoomBest;
    QAction *mActContinous;
    QAction *mActRubberBand;
    QAction *mActInvertcolors;
    QActionGroup *alignLayoutMode;
    QAction *mActSinglePage;
    QAction *mActTwoPages;

    QList<QAction*>mListEditPdf;
    QList<QAction*>mListViewPdf;
    QList<QAction*>mListToolBarPdf;
};

#endif // ACTIONS_H
