/* Copyright © Abouzakaria
 * (c)GPL2 (c)GPL3
 *
 * This file is part of booksorg.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License version 2 or at your option version 3 as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "editbookdialog.h"
#include "ui_editbookdialog.h"
#include <QSettings>
#include <QFileInfo>
#include <QApplication>
#include <QDir>
#include <QTextCodec>
#include <QDebug>
#define thumbnails QDir::homePath()+"/."+QApplication::applicationName()+"/thumbnails"
#define BooksPath QDir::homePath()+"/."+QApplication::applicationName()+"/books"

EditBookDialog::EditBookDialog(const bool &isRoot, QWidget *parent) :
    QDialog(parent),
    ui(new Ui::EditBookDialog)
{
    ui->setupUi(this);


 mRatingWidget =new RatingWidget(false);
  ui->horizontalLayout->addWidget(mRatingWidget);

    if(isRoot){
        mPath=mPath+"/.directory";
        ui->comboBoxAuthors->setVisible(false);
        ui->lineEditPath->setVisible(false);
        ui->labelAuthor->setVisible(false);
        ui->labelPath->setVisible(false);
        ui->labelStars->setVisible(false);
       mRatingWidget->setVisible(false);
        ui->labelGroup->setVisible(false);
        ui->comboBoxGroup->setVisible(false);
        ui->lineEditComment->setVisible(false);
        ui->labelComment->setVisible(false);
    }



}

EditBookDialog::~EditBookDialog()
{
    delete ui;
}


void EditBookDialog::accept()
{
    QDialog::accept();
}


QString EditBookDialog::path()
{
   return ui->lineEditPath->text();
}

QString EditBookDialog::title()
{
    return ui->lineEditTitle->text();
}

QString EditBookDialog::comment()
{
     return ui->lineEditComment->text();
}

QString EditBookDialog::author()
{
     return ui->comboBoxAuthors->currentText();
}

QString EditBookDialog::group()
{
     return ui->comboBoxGroup->currentText();
}

int EditBookDialog::rating()
{
    return mRatingWidget->rating();
}

void EditBookDialog::setPath(const QString &arg)
{
    ui->lineEditPath->setText(arg);
}

void EditBookDialog::setTitle(const QString &arg)
{
    ui->lineEditTitle->setText(arg);
}

void EditBookDialog::setComment(const QString &arg)
{
     ui->lineEditComment->setText(arg);
}

void EditBookDialog::setAuthor(const QStringList &list, const QString &arg)
{
      ui->comboBoxAuthors->addItems(list);
     ui->comboBoxAuthors->setCurrentIndex(-1);
     ui->comboBoxAuthors->setEditText(arg);

}

void EditBookDialog::setGroup(const QStringList &list, const QString &arg)
{
    ui->comboBoxGroup->addItems(list);
    ui->comboBoxGroup->setCurrentIndex(-1);
    ui->comboBoxGroup->setEditText(arg);

}
void EditBookDialog::setRating(const int &arg)
{

mRatingWidget->setRating(arg);

}

void EditBookDialog::setIcon(const QIcon &arg)
{
    ui->toolButtonImage->setIcon(arg);
}

