/* Copyright © Abouzakaria
 * (c)GPL2 (c)GPL3
 *
 * This file is part of booksorg.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License version 2 or at your option version 3 as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef EDITBOOKDIALOG_H
#define EDITBOOKDIALOG_H
#include "ratingwidget.h"
#include <QDialog>

namespace Ui {
class EditBookDialog;
}

class EditBookDialog : public QDialog
{
    Q_OBJECT
    
public:
    explicit EditBookDialog(const bool &isRoot, QWidget *parent = 0);
    ~EditBookDialog();

    QString path();
    QString title();
    QString comment();
    QString author();
    QString group();
    int rating();

    void setPath(const QString &arg);
    void setTitle(const QString &arg);
    void setComment(const QString &arg);
    void setAuthor(const QStringList &list, const QString &arg);
    void setGroup(const QStringList &list, const QString &arg);

    void setRating(const int &arg);
    void setIcon(const QIcon &arg);

private:
    Ui::EditBookDialog *ui;
  RatingWidget *mRatingWidget;
    QString mPath;
    int mRating;
private slots:
    void accept();
//    void setNewRating();

};

#endif // EDITBOOKDIALOG_H
