#include "ratingwidget.h"
#include <QToolButton>
#include <QLayout>
#include <QLabel>
#include <QDebug>

RatingWidget::RatingWidget(bool saveDlg, QWidget *parent) :
    QWidget(parent),mShowSave(saveDlg)
{

    QGridLayout *horizontalLayout = new QGridLayout(this);
  //  horizontalLayout->setObjectName(QStringLiteral("horizontalLayout"));
    //   QLabel*  labelStars = new QLabel(tr("Rating :"),this);
    //    labelStars->setObjectName(QStringLiteral("labelStars"));


    //    horizontalLayout->addWidget(labelStars);

    mWidgetStars = new QWidget(this);
   mWidgetStars->setObjectName("widgetStars");
    mWidgetStars->setMinimumSize(QSize(80, 16));
    mWidgetStars->setMaximumSize(QSize(80, 16));
    mWidgetStars->setCursor(QCursor(Qt::PointingHandCursor));
    mWidgetStars->setLayoutDirection(Qt::LeftToRight);
    mWidgetStars->setStyleSheet(QLatin1String("QWidget#widgetStars{border-image: url(:/icons/0.png);}\n"
                                              ""));
    horizontalLayout->addWidget(mWidgetStars);

    QHBoxLayout *hLayoutButtons = new QHBoxLayout(mWidgetStars);
    hLayoutButtons->setContentsMargins(0,0,0,0);

    for (int i = 0; i < 5; ++i) {
        QToolButton *btn=new QToolButton;
        btn->setObjectName("btn_"+QString::number(i+1));
        //  qDebug()<<btn->objectName();
        btn->setMinimumSize(16,16);
        btn->setMaximumSize(16,16);

        btn->setStyleSheet("QToolButton{background-color:transparent;border-color: transparent;border-radius:0;}");

        hLayoutButtons->addWidget(btn);
        connect(btn,SIGNAL(clicked()),this,SLOT(setNewRating()));

    }

    mButtonBox = new QDialogButtonBox(this);
    //mButtonBox->setObjectName(QStringLiteral("buttonBox"));
    mButtonBox->setCenterButtons(true);
    mButtonBox->setSizePolicy(QSizePolicy::Fixed,QSizePolicy::Fixed);
    mButtonBox->setOrientation(Qt::Horizontal);
    mButtonBox->setStandardButtons(QDialogButtonBox::Cancel|QDialogButtonBox::Save);
    connect(mButtonBox,SIGNAL(clicked(QAbstractButton*)),this,SLOT(buttonBoxClicked(QAbstractButton*)));
    horizontalLayout->addWidget(mButtonBox);
    mButtonBox->setVisible(false);

//    setRating(mRating);
    clearRating();
}
void RatingWidget::setRating(int r, QString file)
{
  qDebug()<<"setRating"<<file<<r;
    mRating=r;
      mFile=file;
    //  qDebug()<<file;
    mWidgetStars->setStyleSheet(
                QString("QWidget#widgetStars{border-image: url(:/icons/%1.png);}")
                .arg(QString::number(r)));
  mButtonBox->setVisible(false);

}
void RatingWidget::clearRating()
{

      mRating=0;
      mFile=QString();

    mWidgetStars->setStyleSheet( QString("QWidget#widgetStars{}"));

     mButtonBox->setVisible(false);

}

void RatingWidget::setNewRating()
{
    QToolButton *action = qobject_cast<QToolButton *>(sender());
    if(action)
    {

        QString s=action->objectName().section("_",1,1);
        if(mRating==s.toInt()){
            mRating=mRating-1;
        }else{
            mRating=s.toInt();
        }
         setRating(mRating,mFile);

if(mShowSave)
        mButtonBox->setVisible(true);
    }
}

void RatingWidget::buttonBoxClicked(QAbstractButton* button)
{
    mButtonBox->setVisible(false);
    if(mButtonBox->standardButton(button)==QDialogButtonBox::Save)
        emit ratingChanged(mRating,mFile);

qDebug()<<"emit saveRatingWidget"<<mFile<<mRating;
}

