#ifndef WIDGETBOOKMARK_H
#define WIDGETBOOKMARK_H

#include <QWidget>
#include <QTreeWidget>
#include <QToolBar>
#include <QAction>

class WidgetBookmark : public QWidget
{
    Q_OBJECT

public:

    //! البناء
    explicit WidgetBookmark(QWidget *parent = 0);

signals:

    //! اشارة لفتح ملف
    void openDocument(const QString,int,qreal,qreal);

    //! اشارة لجلب معلومات الصفحة الحالية
    void getBookmark();

public slots:

    //! اضافة مفضلة جديدة
    void addBookmark(const QString &path, int page, qreal left, qreal top, const QString &str=QString());

private slots:

    //! حفظ المفظلات
    void saveBookmarkSettings();

    //! تحميل المفظلات
    void loadBookmarkSettings();

    //! تفعيل عنصر المفظلة
    void treeWidgetBookmarkItemActivated(QTreeWidgetItem *item, int);

    //!  حذف المفظلة المحددة
    void removeBookmark();

    //! اعادة تسمية المحددة
    void renameBookmark();

    //! القائمة المنسدلة
    void customMenuBookmark(QPoint);

private:

    QTreeWidget *treeWidgetBookmark;
    QToolBar       *mToolBarBookmark;
    QAction         *actAddBookmark;


};

#endif // WIDGETBOOKMARK_H
